local M = {}

local helper = require('scenario/scenariohelper')
local reset = true
local start = false
local stop = false
local primed = false
local death = false
local darkness = 0
local singularityPos = 227
local nuclearPos = -2842.79
local placeHolder = 0
local timer = 0
local timer2 = 0
local timer3 = 0
local endTimer = 0
local windX = 0
local windY = 0
local windZ = 0
local discSpeed = 16
local player = scenetree.findObject('scenario_player0')
local coils = {["rotation"] = 0, ["coil1"] = false, ["coil2"] = false, ["coil3"] = false, ["coil4"] = false, ["particle1"] = true, ["particle2"] = true, ["particle3"] = true, ["particle4"] = true}
local blackhole = {["expandAccDisc"] = true, ["shutdown"] = false, ["radiation"] = false, ["secondEdition"] = false, ["thirdEdition"] = false, ["teleport"] = false, ["havoc"] = false, ["launchNuclear"] = false, ["reverse"] = false, ["spoolTurbines"] = false, ["primed"] = false, ["end"] = false, ["blackholeVar"] = 0, ["scale"] = 0, ["rotation"] = 0}
local coilParticles = {["motionX1"] = -796.691, ["motionY1"] = -338.99, ["motionZ1"] = 251.865, ["motionX2"] = 133.063, ["motionY2"] = -921.071, ["motionZ2"] = 152.27, ["motionX3"] = 831.291, ["motionY3"] = -339.294, ["motionZ3"] = 151.818, ["motionX4"] = 134.183, ["motionY4"] = 5.27905, ["motionZ4"] = 186.168}
local radiationEmitter = {["scale"] = 0, ["rotation"] = 0, ["velocityX"] = 134.241, ["velocityY"] = -372.33, ["velocityZ"] = 233.81}
local turbine = {["rotation"] = 0, ["incrementFactor"] = 0}
local accelerator = {["rotation"] = 0, ["incrementFactor"] = 0, ["activate"] = false, ["charge"] = false, ["beamScale"] = 0}
local explosion = {["scale"] = 0, ["nuclearDissipation"] = 0, ["rotation"] = 0}

local function onScenarioChange(scenario)
	if scenario.state == 'pre-start' then
		reset = true
		stop = false
		primed = false
		death = false
		timer = 0
		timer2 = 0
		timer3 = 0
		endTimer = 0
		placeHolder = 0
		darkness = 0
		singularityPos = 227
		nuclearPos = -2842.79
		discSpeed = 16
		windX = 0
		windY = 0
		windZ = 0
		blackhole = {["expandAccDisc"] = true, ["shutdown"] = false, ["radiation"] = false, ["secondEdition"] = false, ["thirdEdition"] = false, ["teleport"] = false, ["havoc"] = false, ["launchNuclear"] = false, ["reverse"] = false, ["spoolTurbines"] = false, ["primed"] = false, ["end"] = false, ["blackholeVar"] = 0, ["scale"] = 0, ["rotation"] = 0}
		coils = {["rotation"] = 0, ["coil1"] = false, ["coil2"] = false, ["coil3"] = false, ["coil4"] = false, ["particle1"] = true, ["particle2"] = true, ["particle3"] = true, ["particle4"] = true}
		radiationEmitter = {["scale"] = 0, ["rotation"] = 0, ["velocityX"] = 134.241, ["velocityY"] = -372.33, ["velocityZ"] = 233.81}
		coilParticles = {["motionX1"] = -796.691, ["motionY1"] = -338.99, ["motionZ1"] = 251.865, ["motionX2"] = 133.063, ["motionY2"] = -921.071, ["motionZ2"] = 152.27, ["motionX3"] = 831.291, ["motionY3"] = -339.294, ["motionZ3"] = 151.818, ["motionX4"] = 134.183, ["motionY4"] = 5.27905, ["motionZ4"] = 186.168}
		turbine = {["rotation"] = 0, ["incrementFactor"] = 0}
		accelerator = {["rotation"] = 0, ["incrementFactor"] = 0, ["activate"] = false, ["charge"] = false}
		explosion = {["scale"] = 0,["nuclearDissipation"] = 0, ["rotation"] = 0}
	end
end

local function success(speed)
    local result = {msg = 'There, we gave you a medal, so you can\'t be dissapointed anymore. Also, the damage you did to the car is coming out of your pay check that we don\'t pay you!'}
    scenarios.finish(result)
	blackhole["end"] = false
end

local function fail(reason)
  scenarios.finish({failed = reason})
end

local function fireRadiation()
	radiationEmitter["velocityX"] = radiationEmitter["velocityX"]+2.5/2
	radiationEmitter["velocityY"] = radiationEmitter["velocityY"]+6/2
	radiationEmitter["velocityZ"] = radiationEmitter["velocityZ"]+0.8/2
	
	if radiationEmitter["velocityX"] >= 650 then
		if radiationEmitter["scale"] > 0 then
			radiationEmitter["scale"] = radiationEmitter["scale"]-0.05/2
			TorqueScript.eval([[
				particleGenerator.scale = "]]..radiationEmitter["scale"]..[[ ]]..radiationEmitter["scale"]..[[ ]]..radiationEmitter["scale"]..[[";
			]])
		end
		blackhole["shutdown"] = true
	else
		TorqueScript.eval([[
			particleGenerator.position = "]]..radiationEmitter["velocityX"]..[[ ]]..radiationEmitter["velocityY"]..[[ ]]..radiationEmitter["velocityZ"]..[[";
		]])
	end
	
	if discSpeed > 0.1 then
		discSpeed = discSpeed*0.99
		radiationEmitter["rotation"] = radiationEmitter["rotation"]-discSpeed
		TorqueScript.eval([[
			ringA.rotation = "0 ]]..radiationEmitter["rotation"]..[[ ]]..radiationEmitter["rotation"]..[[ ]]..radiationEmitter["rotation"]..[[";
			ringB.rotation = "0	]]..(90+radiationEmitter["rotation"])..[[ ]]..(90+radiationEmitter["rotation"])..[[ ]]..(90+radiationEmitter["rotation"])..[[";
		]])
	end
end

local function transferEnergy()
	if coilParticles["motionX1"] >= 134.241 then
		TorqueScript.eval([[
			coilParticle1.position = "10000 0 0";
		]])
	else
		coilParticles["motionX1"] = coilParticles["motionX1"]+4
		coilParticles["motionY1"] = coilParticles["motionY1"]-0.2
		TorqueScript.eval([[
			coilParticle1.position = "]]..coilParticles["motionX1"]..[[ ]]..coilParticles["motionY1"]..[[ ]]..coilParticles["motionZ1"]..[[";
		]])
	end
	
	if coilParticles["motionY2"] >= -373.47 then
		TorqueScript.eval([[
			coilParticle2.position = "10000 0 0";
		]])
	else
		coilParticles["motionX2"] = coilParticles["motionX2"]+0.05
		coilParticles["motionY2"] = coilParticles["motionY2"]+2
		coilParticles["motionZ2"] = coilParticles["motionZ2"]+0.3
		TorqueScript.eval([[
			coilParticle2.position = "]]..coilParticles["motionX2"]..[[ ]]..coilParticles["motionY2"]..[[ ]]..coilParticles["motionZ2"]..[[";
		]])
	end
	
	if coilParticles["motionX3"] <= 134.241 then
		TorqueScript.eval([[
			coilParticle3.position = "10000 0 0";
		]])
	else
		coilParticles["motionX3"] = coilParticles["motionX3"]-3.5
		coilParticles["motionY3"] = coilParticles["motionY3"]-0.176
		coilParticles["motionZ3"] = coilParticles["motionZ3"]+0.53
		TorqueScript.eval([[
			coilParticle3.position = "]]..coilParticles["motionX3"]..[[ ]]..coilParticles["motionY3"]..[[ ]]..coilParticles["motionZ3"]..[[";
		]])
	end
	
	if coilParticles["motionY4"] <= -373.47 then
		TorqueScript.eval([[
			coilParticle4.position = "10000 0 0";
		]])
	else
		coilParticles["motionY4"] = coilParticles["motionY4"]-1.5
		coilParticles["motionZ4"] = coilParticles["motionZ4"]+0.3
		TorqueScript.eval([[
			coilParticle4.position = "]]..coilParticles["motionX4"]..[[ ]]..coilParticles["motionY4"]..[[ ]]..coilParticles["motionZ4"]..[[";
		]])
	end
end

local function updateRadEmitter(scaleDown)
	if (coils["coil1"] and coils["coil2"] and coils["coil3"] and coils["coil4"]) and not scaleDown then
		radiationEmitter["rotation"] = radiationEmitter["rotation"]+16/2
		TorqueScript.eval([[
			ringA.rotation = "0 ]]..radiationEmitter["rotation"]..[[ ]]..radiationEmitter["rotation"]..[[ ]]..radiationEmitter["rotation"]..[[";
			ringB.rotation = "0	]]..(90+radiationEmitter["rotation"])..[[ ]]..(90+radiationEmitter["rotation"])..[[ ]]..(90+radiationEmitter["rotation"])..[[";
		]])
		
		transferEnergy()
		
		if radiationEmitter["scale"] < 10 then
			radiationEmitter["scale"] = radiationEmitter["scale"]+0.025/2
			TorqueScript.eval([[
				particleGenerator.scale = "]]..radiationEmitter["scale"]..[[ ]]..radiationEmitter["scale"]..[[ ]]..radiationEmitter["scale"]..[[";
			]])
		elseif radiationEmitter["scale"] < 11 then
			primed = true
			radiationEmitter["scale"] = 11
			ui_message('Anti-particles have been gathered, head to the bridge where it is safe away from the collision.', 10, 'E')
			TorqueScript.eval([[
				secondPhaseMarker.position = "-564.068 -748.644 146.125";
			]])
		end
	elseif scaleDown and not blackhole["secondEdition"] and not blackhole["thirdEdition"] and placeHolder <= 10 then
		fireRadiation()
	end
end

local function updateCoils()
	if coils["coil1"] and coils["particle1"] then
		TorqueScript.eval([[
			coilParticle1.position = "-796.691 -338.99 251.865";
		]])
		coils["particle1"] = false
	end
	if coils["coil2"] and coils["particle2"] then
		TorqueScript.eval([[
			coilParticle2.position = "133.063 -921.071 152.27";
		]])
		coils["particle2"] = false
	end
	if coils["coil3"] and coils["particle3"] then
		TorqueScript.eval([[
			coilParticle3.position = "831.291 -339.294 151.818";
		]])
		coils["particle3"] = false
	end
	if coils["coil4"] and coils["particle4"] then
		TorqueScript.eval([[
			coilParticle4.position = "134.183 5.27905 186.168";
		]])
		coils["particle4"] = false
	end
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'coil1trigger' and not coils["coil1"] then
		ui_message('Coil A Initialised', 3, 'A')
		coils["coil1"] = true
		TorqueScript.eval([[
			coil1Marker.position = "10000 0 0";
		]])
		updateCoils()
	elseif data.triggerName == 'coil2trigger' and not coils["coil2"] then
		ui_message('Coil B Initialised', 3, 'A')
		coils["coil2"] = true
		TorqueScript.eval([[
			coil2Marker.position = "10000 0 0";
		]])
		updateCoils()
	elseif data.triggerName == 'coil3trigger' and not coils["coil3"] then
		ui_message('Coil C Initialised', 3, 'A')
		coils["coil3"] = true
		TorqueScript.eval([[
			coil3Marker.position = "10000 0 0";
		]])
		updateCoils()
	elseif data.triggerName == 'coil4trigger' and not coils["coil4"] then
		ui_message('Coil D Initialised', 3, 'A')
		coils["coil4"] = true
		TorqueScript.eval([[
			coil4Marker.position = "10000 0 0";
		]])
		updateCoils()
	elseif data.triggerName == 'secondPhase' and primed then
		TorqueScript.eval([[
			secondPhaseMarker.position = "10000 0 0";
		]])
		ui_message('Subatomic Particles Fired!', 3, 'F')
		playerInPosition = true
		primed = false
		stop = true
	elseif data.triggerName == 'thirdPhase' then
		if placeHolder == 5 then
			TorqueScript.eval([[
				thirdPhaseMarker1.position = "10000 0 0";
			]])
			placeHolder = 6
		elseif placeHolder == 9 then
			TorqueScript.eval([[
				thirdPhaseMarker2.position = "10000 0 0";
			]])
			blackhole["accelerator"] = true
			placeHolder = 10
		end
		
		stop = true
	elseif data.triggerName == 'activateTurbines' and placeHolder == 7 then
		TorqueScript.eval([[
			thirdPhaseMarker2.position = "-532.022 287.127 293.015";
		]])
		placeHolder = 8
		blackhole["spoolTurbines"] = true
	elseif data.triggerName == 'fourthPhase' then
		TorqueScript.eval([[
			fourthPhaseMarker.position = "10000 0 0";
		]])
		placeHolder = 13
		accelerator["activate"] = true
		blackhole["thirdEdition"] = false
		blackhole["radiation"] = true
		ui_message('Blackhole State: ACCELERATED', 5, 'Z')
	elseif data.triggerName == 'exit' and placeHolder == 14 then
		TorqueScript.eval([[
			lastPhaseMarker.position = "10000 0 0";
			beam.scale = "0 0 0";
			areaOfEffect.position = "134.241 -373.47 145.26";
			stem.position = "134.241 -373.47 308.813";
			mushroomCloud.position = "134.241 -373.47 872.883";
			accretionDiscE.position = "10000 0 0";
		]])
		blackhole["explode"] = true
		blackhole["havoc"] = false
		placeHolder = 15
	elseif data.triggerName == 'blackholeGravInc' then
		 local player = scenetree.findObject('scenario_player0')
		 player:queueLuaCommand('obj:setWind(250, 600, 80)')
		 death = true
	elseif data.triggerName == 'blackholeDeathPoint' then
		fail('You do realise you are not meant to drive near the big spiny death thing? OK? Cars cost money, you know!')
	end
end

local function onRaceStart()
	if not start then start = true end
end

local function updateBlackhole()
	if blackhole["expandAccDisc"] then
		if not blackhole["secondEdition"] then
			blackhole["scale"] = blackhole["scale"]+0.1/2
			TorqueScript.eval([[
				accretionDisc.scale = "]]..blackhole["scale"]..[[ ]]..blackhole["scale"]..[[ ]]..blackhole["scale"]..[[";
			]])
			if blackhole["scale"] >= 5 then
				blackhole["expandAccDisc"] = false
				ui_message('Blackhole State: STABLE', 5, 'Z')
			end
		elseif blackhole["secondEdition"] then
			ui_message('Blackhole State: EXPANDING', 5, 'Z')
			blackhole["scale"] = blackhole["scale"]+0.2/2
			TorqueScript.eval([[
				accretionDiscE.scale = "]]..blackhole["scale"]..[[ ]]..blackhole["scale"]..[[ ]]..blackhole["scale"]..[[";
			]])
			if blackhole["scale"] >= 10 then
				blackhole["expandAccDisc"] = false
				ui_message('Blackhole State: STABLE', 5, 'Z')
			end
		end
	end
	
	if blackhole["secondEdition"] then
		blackhole["rotation"] = blackhole["rotation"]+3/2
		TorqueScript.eval([[
			accretionDiscE.rotation = "0 -1 0 ]]..blackhole["rotation"]..[[";
		]])
	elseif not blackhole["thirdEdition"] then
		blackhole["rotation"] = blackhole["rotation"]+1/2
		TorqueScript.eval([[
			accretionDisc.rotation = "0 -1 0 ]]..blackhole["rotation"]..[[";
		]])
	end
	
	if blackhole["shutdown"] and blackhole["scale"] > 0 then
		blackhole["scale"] = blackhole["scale"]-0.02/2
		TorqueScript.eval([[
			accretionDisc.scale = "]]..blackhole["scale"]..[[ ]]..blackhole["scale"]..[[ ]]..blackhole["scale"]..[[";
		]])
	elseif blackhole["shutdown"] then
		ui_message('Blackhole State: UNSTABLE', 5, 'Z')
		blackhole["secondEdition"] = true
		discSpeed = 1
		blackhole["shutdown"] = false
		ui_message('Ah, there might be a slight complication...', 5, 'B')
	end
	
	if blackhole["secondEdition"] and not blackhole["teleport"] and not blackhole["havoc"] then
		discSpeed = discSpeed*1.01
		singularityPos = singularityPos+2/2
		blackhole["scale"] = blackhole["scale"]+0.02
		radiationEmitter["rotation"] = radiationEmitter["rotation"]+(discSpeed)
		TorqueScript.eval([[
			accretionDiscE.position = "85.4042 -372.33 555.857";
			ringA.rotation = "0 ]]..radiationEmitter["rotation"]..[[ ]]..radiationEmitter["rotation"]..[[ ]]..radiationEmitter["rotation"]..[[";
			ringB.rotation = "0	]]..(90+radiationEmitter["rotation"])..[[ ]]..(90+radiationEmitter["rotation"])..[[ ]]..(90+radiationEmitter["rotation"])..[[";
		]])
		
		if blackhole["scale"] >= 6 and blackhole["scale"] <= 9 then
			TorqueScript.eval([[
				ringA.scale = "]]..((9-blackhole["scale"]))..[[ ]]..((9-blackhole["scale"]))..[[ ]]..((9-blackhole["scale"]))..[[";
				ringB.scale = "]]..((9-blackhole["scale"]))..[[ ]]..((9-blackhole["scale"]))..[[ ]]..((9-blackhole["scale"]))..[[";
			]])
		end
		
		if singularityPos < 556*2 then
			TorqueScript.eval([[
				singularity.position = "134.241 -373.47 ]]..singularityPos..[[";
			]])
		end
		
		if discSpeed > 49*2 and discSpeed < 50*2 then
			ui_message('Didn\'t think about that - the anti-particles want to collide with the normal particles.', 10, 'C')
			ui_message('The blackhole seems to want to join in. We just teleported it and made it angry...!', 10, 'D')
			ui_message('Blackhole State: QUANTUM TUNNELLING', 5, 'Z')
		elseif discSpeed >= 550*2 then
			blackhole["teleport"] = true
		end
	end
	
	if blackhole["teleport"] then
		blackhole["expandAccDisc"] = true
		blackhole["havoc"] = true
		blackhole["launchNuclear"] = true
		blackhole["scale"] = 0
		blackhole["teleport"] = false
		TorqueScript.eval([[
			singularity.position = "10000 0 0";
			blackhole.position = "85.4042 -372.33 555.857";
			platform.position = "85.4042 -372.33 555.857";
		]])
	end
	
	if blackhole["thirdEdition"] then
		if blackhole["blackholeVar"] <= 0 then blackhole["reverse"] = false
		elseif blackhole["blackholeVar"] >= 20-3 then blackhole["reverse"] = true
		end
		
		if blackhole["reverse"] == false then blackhole["blackholeVar"] = blackhole["blackholeVar"]+0.2
		elseif blackhole["reverse"] then blackhole["blackholeVar"] = blackhole["blackholeVar"]-0.2
		end
		
		blackhole["rotation"] = blackhole["rotation"]+3+blackhole["blackholeVar"]
		TorqueScript.eval([[
			accretionDiscE.rotation = "0 -1 0 ]]..blackhole["rotation"]..[[";
		]])
	end
	
	if blackhole["radiation"] then
		if blackhole["scale"] > 0 then
			TorqueScript.eval([[
				accretionDiscE.scale = "]]..blackhole["scale"]..[[ ]]..blackhole["scale"]..[[ ]]..blackhole["scale"]..[[";
			]])
			blackhole["scale"] = blackhole["scale"]-0.005/2
		else
			blackhole["scale"] = 0
			blackhole["radiation"] = false
			blackhole["primed"] = true
		end
		
		if blackhole["blackholeVar"] < 250-3 then 
			blackhole["blackholeVar"] = blackhole["blackholeVar"]+0.1	
		end
		
		blackhole["rotation"] = blackhole["rotation"]+3+blackhole["blackholeVar"]
		TorqueScript.eval([[
			accretionDiscE.rotation = "0 -1 0 ]]..blackhole["rotation"]..[[";
		]])
	end
end

local function launchNuclearMissile()
	if placeHolder == 0 then
		ui_message('This is not good...that\'s it, no messing around, it\'s time to nuke it!', 10, 'F')
		placeHolder = 1
	end
	
	nuclearPos = nuclearPos+5
	
	if nuclearPos < -373.47 then
		TorqueScript.eval([[
			nuclearWeapon.position = "134.241 ]]..nuclearPos..[[ 500";
		]])
	else
		TorqueScript.eval([[
			nuclearWeapon.position = "10000 0 0";
			nuclearFallout.position = "134.241 -373.47 500";			
		]])
		blackhole["launchNuclear"] = false
		blackhole["secondEdition"] = false
		blackhole["thirdEdition"] = true
		ui_message('Ok, so nuking it made it worst. Good to know.', 10, 'G')
		placeHolder = 2
		ui_message('Blackhole State: ROTATIONAL AND AXIAL INSTABILITY', 5, 'Z')
	end
end

local function displayMessages(tickTime)
	if placeHolder > 1 and placeHolder < 12 then
		timer = timer+tickTime
		if timer >= 1 and timer <= 2 then
			TorqueScript.eval([[
				nuclearFallout.position = "100000 0 0";		
			]])
		end
		if timer >= 10 and timer <= 11 and placeHolder == 2 then 
			placeHolder = 3
			ui_message('There must be something we can do...', 5, 'G')
		elseif timer >= 16 and timer <= 17 and placeHolder == 3 then 
			ui_message('There is one thing; to disappate the blackhole, you need to speed up time.', 10, 'H')
			placeHolder = 4
		elseif placeHolder == 4 then 
			ui_message('Head up to the central control building, it\'s our only chance now...', 10, 'I') 
			TorqueScript.eval([[
				thirdPhaseMarker1.position = "-532.022 287.127 293.015";
			]])
			placeHolder = 5
		elseif placeHolder == 6 then
			ui_message('You will need to turn on the turbines; restore the connection to the empty batteries.', 10, 'I') 
			TorqueScript.eval([[
				thirdPhaseMarker2.position = "-881.549 607.882 261.497";
			]])
			placeHolder = 7
		elseif placeHolder == 8 then
			ui_message('Great! Return to the control panel and activate the accelerator.', 10, 'I') 
			placeHolder = 9
		elseif placeHolder == 10 then
			ui_message('The time accelerator is powering up. Wait a minute and then fire it.', 10, 'I') 
			placeHolder = 11
			accelerator["charge"] = true
		elseif accelerator["incrementFactor"] == 61 and placeHolder == 11 then
			ui_message('Fire when ready!', 10, 'I') 
			placeHolder = 12
		end
	elseif accelerator["activate"] and placeHolder == 13 then
		timer2 = timer2+tickTime
		if timer2 >= 0 and timer2 <= 1 then ui_message('There is one thing I just remembered...', 5, 'J')
		elseif timer2 >= 6 and timer2 <= 7 then ui_message('Once a blackhole loses its mass through hawking radiation, at the last moment of its life...', 5, 'J')
		elseif timer2 >= 12 and timer2 <= 13 then ui_message('It release all its energy at once; equating to an explosion...', 5, 'J')
		elseif timer2 >= 18 and timer2 <= 19 then ui_message('This blackhole will release 370 Peta Joules of energy...', 5, 'J')
		elseif timer2 >= 24 and timer2 <= 25 then ui_message('Or 88 megatonnes of tnt, around 3874x more energy than the Hiroshma explosion...', 5, 'J')
		elseif timer2 >= 30 and timer2 <= 31 then
			ui_message('With that in mind, get to the Kinetic Energy Absortion Building as fast as possible!', 10, 'J')
			TorqueScript.eval([[
				lastPhaseMarker.position = "-1083.38 -761.786 178.097";
			]])
			placeHolder = 14
		end
	end
end

local function updateTurbines()
	if turbine["incrementFactor"] < 25 then 
		turbine["incrementFactor"] = turbine["incrementFactor"]+0.1 
	end
	
	turbine["rotation"] = turbine["rotation"]+turbine["incrementFactor"]
	
	TorqueScript.eval([[
		turbine1.rotation =  "0 0 1 ]]..turbine["rotation"]..[[";
		turbine2.rotation =  "0 0 1 ]]..turbine["rotation"]..[[";
		turbine3.rotation =  "0 0 1 ]]..turbine["rotation"]..[[";
		turbine4.rotation =  "0 0 1 ]]..turbine["rotation"]..[[";
		turbine5.rotation =  "0 0 1 ]]..turbine["rotation"]..[[";
		turbine6.rotation =  "0 0 1 ]]..turbine["rotation"]..[[";
		turbine7.rotation =  "0 0 1 ]]..turbine["rotation"]..[[";
		turbine8.rotation =  "0 0 1 ]]..turbine["rotation"]..[[";
		turbine9.rotation =  "0 0 1 ]]..turbine["rotation"]..[[";
		turbine10.rotation = "0 0 1 ]]..turbine["rotation"]..[[";
		turbine11.rotation = "0 0 1 ]]..turbine["rotation"]..[[";
	]])
end

local function updateAccelerator()
	if accelerator["incrementFactor"] < 60 then 
		accelerator["incrementFactor"] = accelerator["incrementFactor"]+0.1/2
	elseif accelerator["incrementFactor"] >= 60 and accelerator["incrementFactor"] < 60.9 then
		TorqueScript.eval([[
			fourthPhaseMarker.position = "-494.721 287.713 292.039";
		]])
		ui_message('Charge: 100%', 1,'Q')
		accelerator["incrementFactor"] = 61
	end
	
	accelerator["rotation"] = accelerator["rotation"]+accelerator["incrementFactor"]
	TorqueScript.eval([[
		acceleratorCore.rotation =        "0 -1 0 ]]..accelerator["rotation"]..[[";
		acceleratorRing.rotation =        "0 -1 0 ]]..-accelerator["rotation"]..[[";
		acceleratorStabiliser1.rotation = "0 -1 0 ]]..accelerator["rotation"]..[[";
		acceleratorStabiliser2.rotation = "0 -1 0 ]]..-accelerator["rotation"]..[[";
	]])
	
	if accelerator["activate"] then
		TorqueScript.eval([[
			beam.scale =    "30 1250 30";
			beam.rotation = "0 -1 0 ]]..accelerator["rotation"]..[[";
		]])
	end
end

local function explode(dt)
	if explosion["scale"] < 1000 and explosion["nuclearDissipation"] <= 0 then 
		explosion["scale"] = explosion["scale"]+10/2
		TorqueScript.eval([[
			clouds1.coverage =     "]]..((5/1000)*explosion["scale"])..[[";
			areaOfEffect.scale =   "]]..explosion["scale"]..[[ ]]..explosion["scale"]..[[ 1";
			stem.scale =           "]]..((50/1000)*explosion["scale"])..[[ ]]..((50/1000)*explosion["scale"])..[[ ]]..((200/1000)*explosion["scale"])..[[";
			mushroomCloud.scale =  "]]..((200/1000)*explosion["scale"])..[[ ]]..((200/1000)*explosion["scale"])..[[ ]]..((100/1000)*explosion["scale"])..[[";
		]])
	else
		explosion["nuclearDissipation"] = explosion["nuclearDissipation"]+dt
		if explosion["nuclearDissipation"] >= 15 then
			if explosion["scale"] > 0 then 
				explosion["scale"] = explosion["scale"]-10/2
				TorqueScript.eval([[
					clouds1.coverage =     "]]..((5/1000)*explosion["scale"])..[[";
					areaOfEffect.scale =   "]]..explosion["scale"]..[[ ]]..explosion["scale"]..[[ 1";
					stem.scale =           "]]..((50/1000)*explosion["scale"])..[[ ]]..((50/1000)*explosion["scale"])..[[ ]]..((200/1000)*explosion["scale"])..[[";
					mushroomCloud.scale =  "]]..((200/1000)*explosion["scale"])..[[ ]]..((200/1000)*explosion["scale"])..[[ ]]..((100/1000)*explosion["scale"])..[[";
					
					acceleratorRing.position = "85.4042 1401.2 380.517";
					acceleratorRing.rotation = "0.775653 0.13741 0.61602 199.632";
					acceleratorCore.position = "388.978 786.33 240.173";
					acceleratorStabiliser1.position = "686.81 117.402 143.638";
					acceleratorStabiliser1.rotation = "1 0 0 79.83";
					acceleratorStabiliser2.position = "84.9909 276.237 132.901";
					acceleratorStabiliser2.rotation = "-0.0498534 0.738516 0.672391 145.607";
					beam.scale = "10000 0 0";
				]])
			else
				TorqueScript.eval([[
					clouds1.coverage = "0.09";
				]])
				if explosion["nuclearDissipation"] >= 20 and explosion["nuclearDissipation"] <= 21 then ui_message('The explosion has dissipated now, it is safe to exit the building.', 10, 'K')
				elseif explosion["nuclearDissipation"] >= 31 and explosion["nuclearDissipation"] <= 32 then
					ui_message('Well...that went spectacularly well...I suppose, it\'s well...simulation over!', 10, 'K')
				elseif explosion["nuclearDissipation"] >= 42 and explosion["nuclearDissipation"] <= 43 then
					TorqueScript.eval([[
						sunsky.skyBrightness = "0";
					]])
					local thePlayer = scenetree.findObject('scenario_player0')
					thePlayer:queueLuaCommand('scenario.freeze(1)')
					ui_message('You\'re dissapointed that this is just a simulation?', 5, 'A')
				elseif explosion["nuclearDissipation"] >= 48 and explosion["nuclearDissipation"] <= 49 then
					ui_message('You do realise that this simulation was to test the strength in this new SBR?', 8, 'A')
				elseif explosion["nuclearDissipation"] >= 57 and explosion["nuclearDissipation"] <= 58 then
					ui_message('Fine, if this is what you want...Have fun!', 5, 'A')
				elseif explosion["nuclearDissipation"] >= 63 and explosion["nuclearDissipation"] <= 64 then
					local gravityCommand = 'obj:setGravity(0)'
					local playerCar = scenetree.findObject('scenario_player0')
					playerCar:queueLuaCommand(gravityCommand)
					blackhole["end"] = true
					blackhole["explode"] = false
				end
			end
		end
	end
	
	explosion["rotation"] = explosion["rotation"]+15/2
	TorqueScript.eval([[
		areaOfEffect.rotation =   "0 0 1 ]]..(explosion["rotation"]-14.9)..[[";
		stem.rotation =           "0 0 1 ]]..-explosion["rotation"]..[[";
		mushroomCloud.rotation =  "0 0 1 ]]..explosion["rotation"]..[[";
	]])
end

local function onPreRender(dt)
	if start then
		updateBlackhole()
		updateRadEmitter(stop)
	end
	
	if blackhole["launchNuclear"] then launchNuclearMissile() end
	
	if blackhole["spoolTurbines"] then updateTurbines() end
	
	if accelerator["charge"] then updateAccelerator() end
	
	if blackhole["explode"] then
		explode(dt)
		blackhole["spoolTurbines"] = false
		accelerator["charge"] = false
	end
	
	if blackhole["end"] and endTimer < 14 then
		endTimer = endTimer+dt
		if endTimer < 10 then
			blackhole["rotation"] = blackhole["rotation"]+20
			TorqueScript.eval([[
				accretionDisc.rotation = "0 -1 0 ]]..blackhole["rotation"]..[[";
			]])
			TorqueScript.eval([[
				scenario_player0.position = "0 0 100000";
				accretionDisc.position = "0 3000 100000";
				accretionDisc.scale = "100 100 100";
				sunsky.skyBrightness = "1";
			]])
		elseif endTimer < 13 then
			ui_message('Wait...that car costs a lot of money!', 3, 'W')
			TorqueScript.eval([[
				scenario_player0.position = "-564.075 -748.641 151";
				scenario_player0.rotation = "0.077441 -0.0289303 0.996577 233.626";
			]])
			local gravitycommand = 'obj:setGravity(9.81)'
			local scenarioCar = scenetree.findObject('scenario_player0')
			scenarioCar:queueLuaCommand(gravitycommand)
		else
			success(endTimer)
		end
	end
	
	if reset then
		TorqueScript.eval([[
			sunsky.skyBrightness = "37";
			coil1Marker.position = "-786.547 -300.173 224.559";
			coil2Marker.position = "132.836 -933.504 92.6265";
			coil3Marker.position = "854.156 -339.035 97.4362";
			coil4Marker.position = "110.756 28.6675 131.452";
			ringA.rotation = "1 0 0 0";
			ringB.rotation = "1 0 0 0";
			ringA.scale = "3 3 3";
			ringB.scale = "3 3 3";
			ringA.position = "134.241 -373.47 227.206";
			ringB.position = "134.241 -373.47 227.206";
			particleGenerator.position = "134.241 -372.33 233.81";
			particleGenerator.scale = "0 0 0";
			accretionDisc.scale = "0 0 0";
			accretionDiscE.scale = "0 0 0";
			accretionDiscE.position = "10000 0 0";
			secondPhaseMarker.position = "10000 0 0";
			thirdPhaseMarker.position = "10000 0 0";
			fourthPhaseMarker.position = "10000 0 0";
			nuclearWeapon.position = "134.241 -2842.79 233.81";
			acceleratorStabiliser1.position = "85.4042 1179.4 555.857";
			acceleratorStabiliser2.position = "81.9437 1306.15 545.074";
			acceleratorCore.position = "85.4042 1241.83 555.857";
			acceleratorRing.position = "85.4042 1241.83 555.857";
			acceleratorStabiliser1.rotation = "1 0 0 0";
			acceleratorStabiliser2.rotation = "0 -1 0 90";
			acceleratorCore.rotation = "1 0 0 0";
			acceleratorRing.rotation = "0 -1 0 76.9128";
			beam.scale = "0 0 0";
			nuclearFallout.position = "100000 0 0";
			coilParticle1.position = "10000 0 0";
			coilParticle2.position = "10000 0 0";
			coilParticle3.position = "10000 0 0";
			coilParticle4.position = "10000 0 0";
			areaOfEffect.position = "10000 0 0";
			stem.position = "10000 0 0;
			mushroomCloud.position = "10000 0 0";
		]])
		reset = false
	end
end

local function onRaceTick(raceTickTime)
	timer3 = timer3+raceTickTime
	if timer3 % 1 == 0 and blackhole["scale"] > 1 and not death then
		local playerObject = scenetree.findObject('scenario_player0')
		local blackholeObject = scenetree.findObject('scenario_player1')
		local player = map.objects[map.objectNames['scenario_player0']]
		local blackhole = map.objects[map.objectNames['scenario_player1']]
		local distance = math.floor(math.abs((player.pos-blackhole.pos):length()))
		
		--ui_message('Distance To Blackhole: '..distance..'', 1, 'A')
		
		if playerObject:getPosition().x > blackholeObject:getPosition().x then 
			windX = -((2700-distance)/50)
		elseif playerObject:getPosition().x < blackholeObject:getPosition().x 
			then windX = ((2700-distance)/50)
		end
		
		if playerObject:getPosition().y > blackholeObject:getPosition().y 
			then windY = -(((2700-distance)*2.4)/50)
		elseif playerObject:getPosition().y < blackholeObject:getPosition().y 
			then windY = (((2700-distance)*2.4)/50)
		end
		
		if playerObject:getPosition().z > blackholeObject:getPosition().z 
			then windZ = -(((2700-distance)*0.32)/50)
		elseif playerObject:getPosition().z < blackholeObject:getPosition().z 
			then windZ = (((2700-distance)*0.32)/50)
		end
	
		local windLuaCommand = 'obj:setWind('..windX..','..windY..','..windZ..')'
		playerObject:queueLuaCommand(windLuaCommand)
	end
	
	displayMessages(raceTickTime)
	
	if blackhole["accelerator"] and accelerator["incrementFactor"] <= 60 then
		local percentage = math.floor((accelerator["incrementFactor"]/60*100))
		ui_message('Charge: '..percentage..'%', 1,'Q')
	end
	
	if blackhole["havoc"] and not blackhole["launchNuclear"] then
		if darkness < 36 then 
			darkness = darkness+1 
			TorqueScript.eval([[
				sunsky.skyBrightness = "]]..(37-darkness)..[[";
			]])
		end
	end
end

M.onScenarioChange = onScenarioChange
M.onPreRender = onPreRender
M.onRaceStart = onRaceStart
M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
return M